/*-
 * Copyright (c) 2010 by Bob Frazier and S.F.T. Inc. - all rights reserved
 *
 * This code is derived from software contributed to The FreeBSD Foundation
 * by Shunsuke Akiyama <akiyama@jp.FreeBSD.org> and is subject to all
 * copyright notices and restrictions that apply to the original
 *'derived from' work, as well as the following:
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Copyright notices from the original 'derived from' work must also be
 *    included, as per items (1) and (2) above.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/
/*-
 * copyright notice from original work:  sys/dev/usb/uplcom.c  (FreeBSD 7.3)
 *                                 sys/dev/usb/serial/uplcom.c (FreeBSD 8.1)
 *
 * Copyright (c) 2001-2003, 2005 Shunsuke Akiyama <akiyama@jp.FreeBSD.org>.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
// the following notice was also included in the original 'derived from' work
/*-
 * Copyright (c) 2001 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Ichiro FUKUHARA (ichiro@ichiro.org).
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *        This product includes software developed by the NetBSD
 *        Foundation, Inc. and its contributors.
 * 4. Neither the name of The NetBSD Foundation nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


//////////////////////////////////////////////////////////////////////////////
//                                  _                                       //
//           _   _   __ _  _ __  __| | _   _  _ __    ___     ___           //
//          | | | | / _` || '__|/ _` || | | || '_ \  / _ \   / __|          //
//          | |_| || (_| || |  | (_| || |_| || | | || (_) |_| (__           //
//           \__,_| \__,_||_|   \__,_| \__,_||_| |_| \___/(_)\___|          //
//                                                                          //
//     Source implementation for uarduno kernel driver for Arduino Uno      //
//                                                                          //
//  NOTE:  modified Allman (BSD) style, indent 2, and NO HARD TABS!         //
//         parameters in '()' indent with first '(' when practical          //
//         no space between '(' and things like 'if' 'for' 'while' fn       //
//         and 'return' does not need the extra '()' now does it?           //
//  if you simply must change the style before putting this in the kernel,  //
//  use the 'indent' utility with approrpiate switches.                     //
//////////////////////////////////////////////////////////////////////////////


//--------------------------------------------------------------------------//
// REVISION HISTORY:                                                        //
// 1.0    12/17/2010:   original                                            //
// 1.01   05/02/2011:   changed call to ucom_detach for 9.x (requested)     //
// 1.02   07/05/2011:   applied same change as above for 8.x (required)     //
//                      change due to sys/dev/usb/serial/usb_serial.c       //
//                      vers 1.11.2.7 dated 5/7/2011                        //
//--------------------------------------------------------------------------//



// The FreeBSD 7.x driver is SIGNFICANTLY different from the
// FreeBSD 8.x driver. Therefore both code bodies have been
// separated into two sections, one for 7.x and one for 8.x
// (it is hoped that in 9.x it will become part of the kernel)
#if KERNELVER < 800000

/////////////////////////////////////////////////////////////////
//   _____                  ____  ____   ____    _____         //
//  |  ___|_ __  ___   ___ | __ )/ ___| |  _ \  |___  |__  __  //
//  | |_  | '__|/ _ \ / _ \|  _ \\___ \ | | | |    / / \ \/ /  //
//  |  _| | |  |  __/|  __/| |_) |___) || |_| |   / /_  >  <   //
//  |_|   |_|   \___| \___||____/|____/ |____/   /_/(_)/_/\_\  //
//                                                             //
/////////////////////////////////////////////////////////////////

#include <sys/cdefs.h>

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/module.h>
#include <sys/malloc.h>
#include <sys/bus.h>
#include <sys/ioccom.h>
#include <sys/fcntl.h>
#include <sys/conf.h>
#include <sys/serial.h>
#include <sys/tty.h>
#include <sys/file.h>
#include <sys/selinfo.h>
#include <sys/proc.h>
#include <sys/poll.h>
#include <sys/sysctl.h>
#include <sys/uio.h>
#include <sys/taskqueue.h>

#include <machine/bus.h>

#include <dev/usb/usb.h>
#include <dev/usb/usbcdc.h>

#include <dev/usb/usbdi.h>
#include <dev/usb/usbdivar.h>
#include <dev/usb/usbdi_util.h>
#include "usbdevs.h"
#include <dev/usb/usb_quirks.h>

#include <dev/usb/ucomvar.h>

#include "uarduno.h" // my device's definitions

// some standard defines, pretty much common to all drivers

SYSCTL_NODE(_hw_usb, OID_AUTO, uarduno, CTLFLAG_RW, 0, "USB uarduno");
#ifdef USB_DEBUG
static int uardunodebug = 0;
//my debug level, of course
SYSCTL_INT(_hw_usb_uarduno, OID_AUTO, debug, CTLFLAG_RW,
           &uardunodebug, 0, "uarduno debug level");

#define DPRINTFN(n, x)  do { \
                                if(uardunodebug > (n)) \
                                        printf x; \
                        } while (0)
#else
#define DPRINTFN(n, x)
#endif
#define DPRINTF(x) DPRINTFN(0, x)

//callback functions - must implement
struct ucom_callback uarduno_callback =
{
  uarduno_get_status,
  uarduno_set,
  uarduno_param,
  NULL, /* uarduno_ioctl, TODO */
  uarduno_open,
  uarduno_close,
  NULL, //uarduno_read
  NULL // uarduno_write
};

static const struct uarduno_product uarduno_products[] =
{

#include "ids.h"
  //'ids.h' is always copied from files / ids.txt(part of the port).
  // it contains the entire list of Vendor ID / Product ID combinations
  // by default it contains a single entry, shown below
  // {0x2341, 0x0001}, //Arduino Uno, vendor 2341 H, product 0001 H
  // You can add more vendor / product ID combinations to the array by
  // editing files / ids.txt, then re - extract and re - install the port.

  {0, 0} //the final entry
};



static device_probe_t uarduno_match;
static device_attach_t uarduno_attach;
static device_detach_t uarduno_detach;

static device_method_t uarduno_methods[] =
{
  /* Device interface */
  DEVMETHOD(device_probe, uarduno_match),
  DEVMETHOD(device_attach, uarduno_attach),
  DEVMETHOD(device_detach, uarduno_detach),
  {0, 0}
};

static driver_t uarduno_driver =
{
  "ucom",
  uarduno_methods,
  sizeof(struct uarduno_softc)
};

DRIVER_MODULE(uarduno, uhub, uarduno_driver, ucom_devclass, usbd_driver_load, 0);
MODULE_DEPEND(uarduno, usb, 1, 1, 1);
MODULE_DEPEND(uarduno, ucom, UCOM_MINVER, UCOM_PREFVER, UCOM_MAXVER);
MODULE_VERSION(uarduno, UARDUNO_MODVER);

static int uardunointerval = UARDUNO_INTR_INTERVAL;



static int sysctl_hw_usb_uarduno_interval(SYSCTL_HANDLER_ARGS)
{
int err, val;

  val = uardunointerval;
  err = sysctl_handle_int(oidp, &val, 0, req);
  if(err != 0 || req->newptr == NULL)
  {
    return err;
  }
  if(0 < val && val <= 1000)
  {
    uardunointerval = val;
  }
  else
  {
    err = EINVAL;
  }

  return err;
}

SYSCTL_PROC(_hw_usb_uarduno, OID_AUTO, interval, CTLTYPE_INT | CTLFLAG_RW,
            0, sizeof(int), sysctl_hw_usb_uarduno_interval,
            "I", "uarduno interrupt pipe interval");

static int uarduno_match(device_t self)
{
struct usb_attach_arg *uaa = device_get_ivars(self);
int i;

  if(uaa->iface != NULL)
  {
    return UMATCH_NONE;
  }

  for (i = 0; uarduno_products[i].vendor != 0; i++)
  {
    if(uarduno_products[i].vendor == uaa->vendor &&
        uarduno_products[i].product == uaa->product)
    {
      return UMATCH_VENDOR_PRODUCT;
    }
  }

  // TODO:  scan based on matching vendor _AND_ interface type, in case of new product codes

  return UMATCH_NONE;
}

static int uarduno_attach(device_t self)
{
struct uarduno_softc *sc = device_get_softc(self);
struct usb_attach_arg *uaa = device_get_ivars(self);
usbd_device_handle dev = uaa->device;
struct ucom_softc *ucom;
usb_config_descriptor_t *cdesc;
usb_interface_descriptor_t *id;
usb_endpoint_descriptor_t *ed;
const char *devname;
usbd_status err;
int i;

  ucom = &sc->sc_ucom;
  ucom->sc_dev = self;
  ucom->sc_udev = dev;
  ucom->sc_iface = uaa->iface;

  devname = device_get_nameunit(ucom->sc_dev);

  DPRINTF(("uarduno attach: sc = %p\n", sc));

  if(uarduno_match(self) == UMATCH_NONE) // double-check
  {
    DPRINTF(("%s: didn't match\n", devname));
    ucom->sc_dying = 1;
    goto error;
  }

#ifdef USB_DEBUG
  /* print the chip type */
  DPRINTF(("uarduno_attach - Vendor %04x Product %04x\n", uaa->vendor, uaa->product));
#endif

  /* initialize endpoints */
  ucom->sc_bulkin_no = ucom->sc_bulkout_no = -1;
  sc->sc_intr_number = -1;
  sc->sc_intr_pipe = NULL;

  /* Move the device into the configured state. */
//  err = my_usbd_set_config_index(dev, UARDUNO_CONFIG_INDEX, 1);
  err = usbd_set_config_no(dev, 1, 1);
  if(err)
  {
    DPRINTF(("%s: failed to set configuration: %s\n",
             devname, usbd_errstr(err)));
    ucom->sc_dying = 1;
    goto error;
  }

  /* get the config descriptor */
  cdesc = usbd_get_config_descriptor(ucom->sc_udev);

  if(cdesc == NULL)
  {
    DPRINTF(("%s: failed to get configuration descriptor\n",
             device_get_nameunit(ucom->sc_dev)));
    ucom->sc_dying = 1;
    goto error;
  }

  /* get the (first/common) interface */
  err = usbd_device2interface_handle(dev, UARDUNO_IFACE_INDEX,
                                     &ucom->sc_iface);
  if(err)
  {
    DPRINTF(("%s: failed to get interface: %s\n",
             devname, usbd_errstr(err)));
    ucom->sc_dying = 1;
    goto error;
  }

  /* Find the interrupt endpoints */

  id = usbd_get_interface_descriptor(ucom->sc_iface);
  sc->sc_iface_number = id->bInterfaceNumber;

  for (i = 0; i < id->bNumEndpoints; i++)
  {
    ed = usbd_interface2endpoint_descriptor(ucom->sc_iface, i);
    if(ed == NULL)
    {
      DPRINTF(("%s: no endpoint descriptor for %d\n",
               device_get_nameunit(ucom->sc_dev), i));
      ucom->sc_dying = 1;
      goto error;
    }

    if(UE_GET_DIR(ed->bEndpointAddress) == UE_DIR_IN &&
        UE_GET_XFERTYPE(ed->bmAttributes) == UE_INTERRUPT)
    {
      sc->sc_intr_number = ed->bEndpointAddress;
      sc->sc_isize = UGETW(ed->wMaxPacketSize);
    }
  }

  if(sc->sc_intr_number == -1)
  {
    DPRINTF(("%s: Could not find interrupt in\n",
             device_get_nameunit(ucom->sc_dev)));
    ucom->sc_dying = 1;
    goto error;
  }

  /* keep interface info for interrupt (also control interface) */
  sc->sc_intr_iface = ucom->sc_iface;
  sc->sc_intr_iface_number = sc->sc_iface_number;

  /*
   * USB-RSAQ1 has two interface (from uplcom driver)
   *
   *  USB-RSAQ1       |  USB-RSAQ2
   * -----------------+-----------------
   * Interface 0      | Interface 0
   *  Interrupt(0x81) |  Interrupt(0x81)
   * -----------------+  BulkIN(0x02)
   * Interface 1      |  BulkOUT(0x83)
   *   BulkIN(0x02)   |
   *   BulkOUT(0x83)  |
   *
   * NOTE:  Arduino Uno appears to behave as USB-RSAQ1
   *
   *  Arduino UNO        |
   * --------------------+
   * Interface 0         |
   *   Interrupt(0x82)   |
   * --------------------+
   * Interface 1         |
   *   BulkIN(0x04)      |
   *   BulkOUT(0x83)     |
  */

  if(cdesc->bNumInterface == 2)
  {
    err = usbd_device2interface_handle(dev,
                                       UARDUNO_SECOND_IFACE_INDEX,
                                       &ucom->sc_iface);
    if(err)
    {
      DPRINTF(("%s: failed to get second interface: %s\n",
               devname, usbd_errstr(err)));
      ucom->sc_dying = 1;
      goto error;
    }
  }
//  else
//  {
//    printf("%s:  SOMETHING IS WRONG, there is no second interface!\n", devname);
//  }

  /* Find the bulk{in,out} endpoints */

  id = usbd_get_interface_descriptor(ucom->sc_iface);
  sc->sc_iface_number = id->bInterfaceNumber;

  ucom->sc_ibufsize = ucom->sc_obufsize = 0;

  for (i = 0; i < id->bNumEndpoints; i++)
  {
    ed = usbd_interface2endpoint_descriptor(ucom->sc_iface, i);
    if(ed == NULL)
    {
      printf("%s: no endpoint descriptor for %d\n",
             device_get_nameunit(ucom->sc_dev), i);
      ucom->sc_dying = 1;
      goto error;
    }

    if(UE_GET_DIR(ed->bEndpointAddress) == UE_DIR_IN &&
        UE_GET_XFERTYPE(ed->bmAttributes) == UE_BULK)
    {
      ucom->sc_bulkin_no = ed->bEndpointAddress;
      ucom->sc_ibufsize = UGETW(ed->wMaxPacketSize);
    }
    else if(UE_GET_DIR(ed->bEndpointAddress) == UE_DIR_OUT &&
             UE_GET_XFERTYPE(ed->bmAttributes) == UE_BULK)
    {
      ucom->sc_bulkout_no = ed->bEndpointAddress;
      ucom->sc_obufsize = UGETW(ed->wMaxPacketSize);
    }
  }

  if(ucom->sc_bulkin_no == -1)
  {
    DPRINTF(("%s: Could not find data bulk in\n",
             device_get_nameunit(ucom->sc_dev)));
    ucom->sc_dying = 1;
    goto error;
  }

  if(ucom->sc_bulkout_no == -1)
  {
    DPRINTF(("%s: Could not find data bulk out\n",
             device_get_nameunit(ucom->sc_dev)));
    ucom->sc_dying = 1;
    goto error;
  }

  sc->sc_dtr = sc->sc_rts = -1;
//  sc->sc_dtr = 0;
//  sc->sc_rts = 0;
  ucom->sc_parent = sc;
  ucom->sc_portno = UARDUNO_PORT; // zero
  // pad the input buffer by adding up to 7 bytes to get 8-byte (64-bit) size alignment
  ucom->sc_ibufsizepad = (ucom->sc_ibufsize + 7) & 0xfffffff8; // align to 8 bytes
  ucom->sc_opkthdrlen = 0;
  ucom->sc_callback = &uarduno_callback;

  err = uarduno_reset(sc);

  if(err)
  {
    DPRINTF(("%s: reset failed: %s\n",
             device_get_nameunit(ucom->sc_dev), usbd_errstr(err)));
    ucom->sc_dying = 1;
    goto error;
  }

  DPRINTF(("uarduno: in = 0x%x, out = 0x%x, intr = 0x%x\n",
           ucom->sc_bulkin_no, ucom->sc_bulkout_no, sc->sc_intr_number));

  TASK_INIT(&sc->sc_task, 0, uarduno_notify, sc);
  ucom_attach(&sc->sc_ucom);
  return 0;

error:
  return ENXIO;
}

static int uarduno_detach(device_t self)
{
struct uarduno_softc *sc = device_get_softc(self);
int rv = 0;

  DPRINTF(("uarduno_detach: sc = %p\n", sc));

  if(sc->sc_intr_pipe != NULL)
  {
    usbd_abort_pipe(sc->sc_intr_pipe);
    usbd_close_pipe(sc->sc_intr_pipe);
    free(sc->sc_intr_buf, M_USBDEV);
    sc->sc_intr_pipe = NULL;
  }

  sc->sc_ucom.sc_dying = 1;

  rv = ucom_detach(&sc->sc_ucom);

  return rv;
}

static usbd_status uarduno_reset(struct uarduno_softc *sc)
{
  return uarduno_set_line_coding(sc, NULL);
}

static usbd_status uarduno_set_line_state(struct uarduno_softc *sc)
{
usb_device_request_t req;
int ls;
usbd_status err;

  ls = (sc->sc_dtr ? UCDC_LINE_DTR : 0)
     | (sc->sc_rts ? UCDC_LINE_RTS : 0);
  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_CONTROL_LINE_STATE; // UARDUNO_SET_CONTROL_LINE_STATE
  USETW(req.wValue, ls);
  USETW(req.wIndex, sc->sc_intr_iface_number);
  USETW(req.wLength, 0);

//  err = usbd_do_request(sc->sc_ucom.sc_udev, &req, 0);
  err = usbd_do_request_flags(sc->sc_ucom.sc_udev, &req, 0, USBD_SHORT_XFER_OK,
                              NULL, USBD_DEFAULT_TIMEOUT);
  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_line_state: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
  }

  return err;
}

static void uarduno_set(void *addr, int portno, int reg, int onoff)
{
struct uarduno_softc *sc = addr;

  switch (reg)
  {
    case UCOM_SET_DTR:
      uarduno_dtr(sc, onoff);
      break;

    case UCOM_SET_RTS:
      uarduno_rts(sc, onoff);
      break;

    case UCOM_SET_BREAK:
      uarduno_break(sc, onoff);
      break;

    default:
      break;
  }
}

static void uarduno_dtr(struct uarduno_softc *sc, int onoff)
{
  DPRINTF(("uarduno_dtr: onoff = %d\n", onoff));

  if(sc->sc_dtr == onoff)
    return;
  sc->sc_dtr = onoff;

  uarduno_set_line_state(sc);
}

static void uarduno_rts(struct uarduno_softc *sc, int onoff)
{
  DPRINTF(("uarduno_rts: onoff = %d\n", onoff));

  if(sc->sc_rts == onoff)
    return;
  sc->sc_rts = onoff;

  uarduno_set_line_state(sc);
}

static void uarduno_break(struct uarduno_softc *sc, int onoff)
{
usb_device_request_t req;
usbd_status err;

  DPRINTF(("uarduno_break: onoff = %d\n", onoff));

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SEND_BREAK;
  USETW(req.wValue, onoff ? UCDC_BREAK_ON : UCDC_BREAK_OFF);
  USETW(req.wIndex, sc->sc_intr_iface_number);
  USETW(req.wLength, 0);

//  err = usbd_do_request(sc->sc_ucom.sc_udev, &req, 0);
  err = usbd_do_request_flags(sc->sc_ucom.sc_udev, &req, 0, USBD_SHORT_XFER_OK,
                              NULL, USBD_DEFAULT_TIMEOUT);
  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_break: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
  }
}

//#define UARDUNO_CONTROL_LINE_OUT_DTR (1 << 0) /* DTR handshake line for use with UARDUNO_SET_CONTROL_LINE_STATE */
//#define UARDUNO_CONTROL_LINE_OUT_RTS (1 << 1) /* RTS handshake line for use with UARDUNO_SET_CONTROL_LINE_STATE */

static usbd_status uarduno_set_crtscts(struct uarduno_softc *sc)
{
  return uarduno_set_line_state(sc);
}

static usb_cdc_line_state_t lsDefault =
{
  .dwDTERate={128,37,0,0}, // USETDW(dwDTERate,9600)
  .bCharFormat=UCDC_STOP_BIT_1,
  .bParityType=UCDC_PARITY_NONE,
  .bDataBits=8
};

static usbd_status uarduno_set_line_coding(struct uarduno_softc *sc, usb_cdc_line_state_t * state)
{
usb_device_request_t req;
usbd_status err;

  if(!state)
  {
    state = &lsDefault;  // this allows me to EASILY set defaults
  }

  DPRINTF(("uarduno_set_line_coding: rate = %d, fmt = %d, parity = %d bits = %d\n",
           UGETDW(state->dwDTERate), state->bCharFormat,
           state->bParityType, state->bDataBits));

  if(memcmp(state, &sc->sc_line_state, UCDC_LINE_STATE_LENGTH) == 0)
  {
    DPRINTF(("uarduno_set_line_coding: already set\n"));
    return USBD_NORMAL_COMPLETION;
  }

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_LINE_CODING;
  USETW(req.wValue, 0);
  USETW(req.wIndex, sc->sc_intr_iface_number);
  USETW(req.wLength, sizeof(*state));//UCDC_LINE_STATE_LENGTH);

//  err = usbd_do_request(sc->sc_ucom.sc_udev, &req, state);
  err = usbd_do_request_flags(sc->sc_ucom.sc_udev, &req, state, USBD_SHORT_XFER_OK,
                              NULL, USBD_DEFAULT_TIMEOUT);

  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_line_coding: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
    return err;
  }

  sc->sc_line_state = *state;

  return USBD_NORMAL_COMPLETION;
}

static const int uarduno_rates[] = {
  75, 150, 300, 600, 1200, 1800, 2400, 3600, 4800, 7200, 9600, 14400,
  19200, 28800, 38400, 57600, 115200,
  230400, 460800, 614400, 921600, 1228800
};
#define N_UARDUNO_RATES (sizeof(uarduno_rates)/sizeof(uarduno_rates[0]))


static int uarduno_param(void *addr, int portno, struct termios *t)
{
struct uarduno_softc *sc = addr;
usbd_status err;
usb_cdc_line_state_t ls;
int i;

  DPRINTF(("uarduno_param: sc = %p\n", sc));

  /* Check requested baud rate */
  for (i = 0; i < N_UARDUNO_RATES; i++)
  {
    if(uarduno_rates[i] == t->c_ospeed)
      break;
  }

  if(i == N_UARDUNO_RATES)
  {
    DPRINTF(("uarduno_param: bad baud rate (%d)\n", t->c_ospeed));
    return EIO;
  }

  USETDW(ls.dwDTERate, t->c_ospeed);

  if(t->c_cflag & CSTOPB)
  {
    ls.bCharFormat = UCDC_STOP_BIT_2;
  }
  else
  {
    ls.bCharFormat = UCDC_STOP_BIT_1;
  }

  if(t->c_cflag & PARENB)
  {
    if(t->c_cflag & PARODD)
    {
      ls.bParityType = UCDC_PARITY_ODD;
    }
    else
    {
      ls.bParityType = UCDC_PARITY_EVEN;
    }
  }
  else
  {
    ls.bParityType = UCDC_PARITY_NONE;
  }

  switch (ISSET(t->c_cflag, CSIZE))
  {
    case CS5:
      ls.bDataBits = 5;
      break;
    case CS6:
      ls.bDataBits = 6;
      break;
    case CS7:
      ls.bDataBits = 7;
      break;
    case CS8:
      ls.bDataBits = 8;
      break;
  }

  err = uarduno_set_line_coding(sc, &ls);
  if(err)
  {
    return EIO;
  }

  if(ISSET(t->c_cflag, CRTSCTS))
  {
    err = uarduno_set_crtscts(sc);
    if(err)
    {
      return EIO;
    }
  }

  return 0;
}

static int uarduno_open(void *addr, int portno)
{
struct uarduno_softc *sc = addr;
int err;

  if(sc->sc_ucom.sc_dying)
  {
    return ENXIO;
  }

  DPRINTF(("uarduno_open: sc = %p\n", sc));

  if(sc->sc_intr_number != -1 && sc->sc_intr_pipe == NULL)
  {
    sc->sc_status = 0;  /* clear status bit */
    sc->sc_intr_buf = malloc(sc->sc_isize, M_USBDEV, M_WAITOK);
    err = usbd_open_pipe_intr(sc->sc_intr_iface,
                              sc->sc_intr_number,
                              USBD_SHORT_XFER_OK,
                              &sc->sc_intr_pipe,
                              sc,
                              sc->sc_intr_buf,
                              sc->sc_isize,
                              uarduno_intr,
                              uardunointerval);
    if(err)
    {
      DPRINTF(("%s: cannot open interrupt pipe (addr %d)\n",
               device_get_nameunit(sc->sc_ucom.sc_dev),
               sc->sc_intr_number));
      return EIO;
    }
  }

  return 0;
}

static void uarduno_close(void *addr, int portno)
{
struct uarduno_softc *sc = addr;
int err;

  if(sc->sc_ucom.sc_dying)
  {
    return;
  }

  DPRINTF(("uarduno_close: close\n"));

  if(sc->sc_intr_pipe != NULL)
  {
    err = usbd_abort_pipe(sc->sc_intr_pipe);
    if(err)
    {
      DPRINTF(("%s: abort interrupt pipe failed: %s\n",
               device_get_nameunit(sc->sc_ucom.sc_dev),
               usbd_errstr(err)));
    }
    err = usbd_close_pipe(sc->sc_intr_pipe);
    if(err)
    {
      DPRINTF(("%s: close interrupt pipe failed: %s\n",
               device_get_nameunit(sc->sc_ucom.sc_dev),
               usbd_errstr(err)));
    }
    free(sc->sc_intr_buf, M_USBDEV);
    sc->sc_intr_pipe = NULL;
  }
}

static void uarduno_intr(usbd_xfer_handle xfer, usbd_private_handle priv, usbd_status status)
{
struct uarduno_softc *sc = priv;
u_char *buf = sc->sc_intr_buf;
u_char pstatus;

  if(sc->sc_ucom.sc_dying)
  {
    return;
  }

  if(status != USBD_NORMAL_COMPLETION)
  {
    if(status == USBD_NOT_STARTED || status == USBD_CANCELLED)
      return;

    DPRINTF(("%s: uarduno_intr: abnormal status: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev),
             usbd_errstr(status)));
    usbd_clear_endpoint_stall_async(sc->sc_intr_pipe);
    return;
  }

  DPRINTF(("%s: uarduno status = %02x\n",
           device_get_nameunit(sc->sc_ucom.sc_dev), buf[8]));

  sc->sc_lsr = sc->sc_msr = 0;
  pstatus = buf[8];

  if(ISSET(pstatus, RSAQ_STATUS_CTS))
  {
    sc->sc_msr |= SER_CTS;
  }
  else
  {
    sc->sc_msr &= ~SER_CTS;
  }

  if(ISSET(pstatus, RSAQ_STATUS_DSR))
  {
    sc->sc_msr |= SER_DSR;
  }
  else
  {
    sc->sc_msr &= ~SER_DSR;
  }

  if(ISSET(pstatus, RSAQ_STATUS_DCD))
  {
    sc->sc_msr |= SER_DCD;
  }
  else
  {
    sc->sc_msr &= ~SER_DCD;
  }

  /* Deferred notifying to the ucom layer */
  taskqueue_enqueue(taskqueue_swi_giant, &sc->sc_task);
}

static void uarduno_notify(void *arg, int count)
{
struct uarduno_softc *sc;

  sc = (struct uarduno_softc *)arg;
  if(sc->sc_ucom.sc_dying)
  {
    return;
  }
  ucom_status_change(&sc->sc_ucom);
}

static void uarduno_get_status(void *addr, int portno, u_char * lsr, u_char * msr)
{
struct uarduno_softc *sc = addr;

  DPRINTF(("uarduno_get_status:\n"));

  if(lsr != NULL)
  {
    *lsr = sc->sc_lsr;
  }

  if(msr != NULL)
  {
    *msr = sc->sc_msr;
  }
}

#if 0   /* TODO */
static int uarduno_ioctl(void *addr, int portno, u_long cmd, caddr_t data, int flag,
                         struct thread *p)
{
struct uarduno_softc *sc = addr;
int error = 0;

  if(sc->sc_ucom.sc_dying)
    return EIO;

  DPRINTF(("uarduno_ioctl: cmd = 0x%08lx\n", cmd));

  switch (cmd)
  {
    case TIOCNOTTY:
    case TIOCMGET:
    case TIOCMSET:
    case USB_GET_CM_OVER_DATA:
    case USB_SET_CM_OVER_DATA:
      break;

    default:
      DPRINTF(("uarduno_ioctl: unknown\n"));
      error = ENOTTY;
      break;
  }

  return error;
}
#endif

#else // KERNELVER >= 800000

///////////////////////////////////////////////////////////////////
//   _____                  ____  ____   ____     ___            //
//  |  ___|_ __  ___   ___ | __ )/ ___| |  _ \   ( _ )   __  __  //
//  | |_  | '__|/ _ \ / _ \|  _ \\___ \ | | | |  / _ \   \ \/ /  //
//  |  _| | |  |  __/|  __/| |_) |___) || |_| | | (_) |_  >  <   //
//  |_|   |_|   \___| \___||____/|____/ |____/   \___/(_)/_/\_\  //
//                                                               //
///////////////////////////////////////////////////////////////////

#include <sys/stdint.h>
#include <sys/stddef.h>
#include <sys/param.h>
#include <sys/queue.h>
#include <sys/types.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/bus.h>
#include <sys/linker_set.h>
#include <sys/module.h>
#include <sys/lock.h>
#include <sys/mutex.h>
#include <sys/condvar.h>
#include <sys/sysctl.h>
#include <sys/sx.h>
#include <sys/unistd.h>
#include <sys/callout.h>
#include <sys/malloc.h>
#include <sys/priv.h>

#include <dev/usb/usb.h>
#include <dev/usb/usbdi.h>
#include <dev/usb/usbdi_util.h>
#include <dev/usb/usb_cdc.h>
#include "usbdevs.h"

#define USB_DEBUG_VAR uarduno_debug
#include <dev/usb/usb_debug.h>
#include <dev/usb/usb_process.h>

#include <dev/usb/serial/usb_serial.h>

#include "uarduno.h"

#ifdef USB_DEBUG
static int uarduno_debug = 0;

SYSCTL_NODE(_hw_usb, OID_AUTO, uarduno, CTLFLAG_RW, 0, "USB uarduno");
SYSCTL_INT(_hw_usb_uarduno, OID_AUTO, debug, CTLFLAG_RW,
    &uarduno_debug, 0, "Debug level");
#endif


static const struct usb_config uarduno_config_data[UARDUNO_N_TRANSFER] =
{
  [UARDUNO_BULK_DT_WR] =
  {
    .type = UE_BULK,
    .endpoint = UE_ADDR_ANY,
    .direction = UE_DIR_OUT,
//        .bufsize = UARDUNO_BULK_BUF_SIZE,
    .bufsize = 0,   /* use wMaxPacketSize */
    .flags = {.pipe_bof = 1,.force_short_xfer = 1,},
    .callback = &uarduno_write_callback,
    .if_index = 0,
  },

  [UARDUNO_BULK_DT_RD] =
  {
    .type = UE_BULK,
    .endpoint = UE_ADDR_ANY,
    .direction = UE_DIR_IN,
//        .bufsize = UARDUNO_BULK_BUF_SIZE,
    .bufsize = 0,   /* use wMaxPacketSize */
    .flags = {.pipe_bof = 1,.short_xfer_ok = 1,},
    .callback = &uarduno_read_callback,
    .if_index = 0,
  },

  [UARDUNO_INTR_DT_RD] =
  {
    .type = UE_INTERRUPT,
    .endpoint = UE_ADDR_ANY,
    .direction = UE_DIR_IN,
    .flags = {.pipe_bof = 1,.short_xfer_ok = 1,},
    .bufsize = 0,   /* use wMaxPacketSize */
    .callback = &uarduno_intr_callback,
    .if_index = 1,
  },
};

static struct ucom_callback uarduno_callback =
{
  .ucom_cfg_get_status = &uarduno_cfg_get_status,
  .ucom_cfg_set_dtr = &uarduno_cfg_set_dtr,
  .ucom_cfg_set_rts = &uarduno_cfg_set_rts,
  .ucom_cfg_set_break = &uarduno_cfg_set_break,
  .ucom_cfg_param = &uarduno_cfg_param,
  .ucom_pre_param = &uarduno_pre_param,
  .ucom_start_read = &uarduno_start_read,
  .ucom_stop_read = &uarduno_stop_read,
  .ucom_start_write = &uarduno_start_write,
  .ucom_stop_write = &uarduno_stop_write,
  .ucom_poll = &uarduno_poll,
};


static const struct uarduno_product uarduno_products[] =
{
#include "ids.h"
  //'ids.h' is always copied from files / ids.txt(part of the port).
  // it contains the entire list of Vendor ID / Product ID combinations
  // by default it contains a single entry, shown below
  // {0x2341, 0x0001}, //Arduino Uno, vendor 2341 H, product 0001 H
  // You can add more vendor / product ID combinations to the array by
  // editing files / ids.txt, then re - extract and re - install the port.

  {0, 0} //the final entry
};


static device_method_t uarduno_methods[] =
{
  DEVMETHOD(device_probe, uarduno_probe),
  DEVMETHOD(device_attach, uarduno_attach),
  DEVMETHOD(device_detach, uarduno_detach),
  {0, 0}
};

static devclass_t uarduno_devclass;

static driver_t uarduno_driver =
{
  .name = "uarduno",
  .methods = uarduno_methods,
  .size = sizeof(struct uarduno_softc),
};

DRIVER_MODULE(uarduno, uhub, uarduno_driver, uarduno_devclass, NULL, 0);
MODULE_DEPEND(uarduno, ucom, 1, 1, 1);
MODULE_DEPEND(uarduno, usb, 1, 1, 1);
MODULE_VERSION(uarduno, UARDUNO_MODVER);

static int uarduno_probe(device_t dev)
{
struct usb_attach_arg *uaa = device_get_ivars(dev);
int i;

  DPRINTFN(11, "\n");

  if(uaa->usb_mode != USB_MODE_HOST)
  {
    return ENXIO;
  }

  if(uaa->info.bConfigIndex != UARDUNO_CONFIG_INDEX)
  {
    return ENXIO;
  }

  if(uaa->info.bIfaceIndex != UARDUNO_IFACE_INDEX)
  {
    return ENXIO;
  }

//  if(uaa->iface != NULL)
//  {
//    return ENXIO;
//  }

  // TODO:  for 8.x, upgrade this method to include some class and protocol definitions

  for (i = 0; uarduno_products[i].vendor != 0; i++)
  {
    if(uarduno_products[i].vendor == uaa->info.idVendor &&
        uarduno_products[i].product == uaa->info.idProduct)
    {
      uaa->driver_info = 0;  // since I'm not using usb_device_t I assign this
      return 0;  // "match"
    }
  }

  // TODO:  scan based on matching vendor _AND_ interface type, in case of new product codes

  return ENXIO; // NOT found

#if 0 // original code, for reference

  struct usb_attach_arg *uaa = device_get_ivars(dev);

  DPRINTFN(11, "\n");

  if(uaa->usb_mode != USB_MODE_HOST)
  {
    return ENXIO;
  }
  if(uaa->info.bConfigIndex != UARDUNO_CONFIG_INDEX)
  {
    return ENXIO;
  }
  if(uaa->info.bIfaceIndex != UARDUNO_IFACE_INDEX)
  {
    return ENXIO;
  }

  // NOTE:  'uarduno_devs' would be an array of usb_device_t structures
  //        of which ONLY the first 5 elements would be filled in
  return usbd_lookup_id_by_uaa(uarduno_devs, sizeof(uarduno_devs), uaa);

#endif // 0
}

static int uarduno_attach(device_t dev)
{
  struct usb_attach_arg *uaa = device_get_ivars(dev);
  struct uarduno_softc *sc = device_get_softc(dev);
  struct usb_interface *iface;
  struct usb_interface_descriptor *id;
  int error;

  DPRINTFN(11, "\n");

  device_set_usb_desc(dev);
  mtx_init(&sc->sc_mtx, "uarduno", NULL, MTX_DEF);

  DPRINTF("sc = %p\n", sc);

//  sc->sc_chiptype = USB_GET_DRIVER_INFO(uaa);
  sc->sc_udev = uaa->device;

//  DPRINTF("chiptype: %s\n",
//          (sc->sc_chiptype == TYPE_PL2303X) ?
//          "2303X" : "2303");

  /*
   * USB-RSAQ1 has two interface
   *
   *  USB-RSAQ1       | USB-RSAQ2
   * -----------------+-----------------
   * Interface 0      |Interface 0
   *  Interrupt(0x81) | Interrupt(0x81)
   * -----------------+ BulkIN(0x02)
   * Interface 1      | BulkOUT(0x83)
   *   BulkIN(0x02)   |
   *   BulkOUT(0x83)  |
   *
   * NOTE:  Arduino Uno appears to behave as USB-RSAQ1
   *
   *  Arduino UNO        |
   * --------------------+
   * Interface 0         |
   *   Interrupt(0x82)   |
   * --------------------+
   * Interface 1         |
   *   BulkIN(0x04)      |
   *   BulkOUT(0x83)     |
  */

  sc->sc_ctrl_iface_no = uaa->info.bIfaceNum;
  sc->sc_iface_index[1] = UARDUNO_IFACE_INDEX;

  iface = usbd_get_iface(uaa->device, UARDUNO_SECOND_IFACE_INDEX);
  if(iface)
  {
    id = usbd_get_interface_descriptor(iface);
    if(id == NULL)
    {
      device_printf(dev, "no interface descriptor (2)\n");
      goto detach;
    }
    sc->sc_data_iface_no = id->bInterfaceNumber;
    sc->sc_iface_index[0] = UARDUNO_SECOND_IFACE_INDEX;
    usbd_set_parent_iface(uaa->device,
                          UARDUNO_SECOND_IFACE_INDEX,
                          uaa->info.bIfaceIndex);
  }
  else
  {
    sc->sc_data_iface_no = sc->sc_ctrl_iface_no;
    sc->sc_iface_index[0] = UARDUNO_IFACE_INDEX;
  }

  error = usbd_transfer_setup(uaa->device,
                              sc->sc_iface_index,
                              sc->sc_xfer, uarduno_config_data,
                              UARDUNO_N_TRANSFER,
                              sc, &sc->sc_mtx);
  if(error)
  {
     DPRINTF("one or more missing USB endpoints, "
             "error=%s\n", usbd_errstr(error));
    goto detach;
  }

  /* clear stall at first run */

  mtx_lock(&sc->sc_mtx);
  usbd_xfer_set_stall(sc->sc_xfer[UARDUNO_BULK_DT_WR]);
  usbd_xfer_set_stall(sc->sc_xfer[UARDUNO_BULK_DT_RD]);
  mtx_unlock(&sc->sc_mtx);

  error = ucom_attach(&sc->sc_super_ucom, &sc->sc_ucom, 1, sc,
                      &uarduno_callback, &sc->sc_mtx);
  if(error) 
  {
    goto detach;
  }

  /*
   * do the initialization during attach so that the system does not
   * sleep during open:
   */

  // NOTE:  MUST attach before I call uarduno_reset (or my I/O proc won't be running)
  // since ucom_attach calls usb_proc_create to create it.

  error = uarduno_reset(sc, uaa->device); // sets default params initially

  if(error)
  {
    device_printf(dev, "reset failed, error=%s\n",
                  usbd_errstr(error));
    goto detach;
  }

  return 0;

detach:
  uarduno_detach(dev);
  return ENXIO;
}

static int uarduno_detach(device_t dev)
{
  struct uarduno_softc *sc = device_get_softc(dev);

  DPRINTF("sc=%p\n", sc);

//#if KERNELVER >= 900000
#if KERNELVER >= 802508
  // changed in 9.x and 8.2 after 5/7/2011 - final parameter removed from ucom_detach
  // NOTE:  I guessed a bit at the KERNELVER - if this does not compile properly on your
  // system please e-mail me a copy of '/usr/obj/usr/src/include/osreldate.h' so that
  // I can fix it properly - thanks
  ucom_detach(&sc->sc_super_ucom, &sc->sc_ucom);
#else // KERNELVER < 802508
  ucom_detach(&sc->sc_super_ucom, &sc->sc_ucom, 1);
#endif // KERNELVER >= 802508
  usbd_transfer_unsetup(sc->sc_xfer, UARDUNO_N_TRANSFER);
  mtx_destroy(&sc->sc_mtx);

  return 0;
}

static struct usb_cdc_line_state lsDefault =
{
  .dwDTERate={128,37,0,0}, // USETDW(dwDTERate,9600)
  .bCharFormat=UCDC_STOP_BIT_1,
  .bParityType=UCDC_PARITY_NONE,
  .bDataBits=8
};

// NOTE:  this is _ONLY_ called by uarduno_reset and therefore it will invoke
// usbd_do_request_flags directly to prevent crashing on attach
static usb_error_t uarduno_set_line_coding_reset(struct uarduno_softc *sc)
{
usb_device_request_t req;
usb_error_t err;
struct usb_cdc_line_state *state = &lsDefault;

  DPRINTF(("uarduno_set_line_coding_reset: rate = %d, fmt = %d, parity = %d bits = %d\n",
           UGETDW(state->dwDTERate), state->bCharFormat,
           state->bParityType, state->bDataBits));

//  if(memcmp(state, &sc->sc_line_state, UCDC_LINE_STATE_LENGTH) == 0)
//  {
//    DPRINTF(("uarduno_set_line_coding_reset: already set\n"));
//    return 0;
//  }

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_LINE_CODING;
  USETW(req.wValue, 0);
//  USETW(req.wIndex, sc->sc_ctrl_iface_no);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, sizeof(*state));//UCDC_LINE_STATE_LENGTH);

//  err = ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
//                            &req, state, 0, 1000);
  err = usbd_do_request_flags(sc->sc_udev, NULL, &req, state, USB_SHORT_XFER_OK,
                              NULL, USB_DEFAULT_TIMEOUT);
  // NOTE:  NO mutex, and basically the same as calling usbd_do_request() but with
  //        short transfer ALWAYS allowed

  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_line_coding_reset: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
    return err;
  }

  sc->sc_line_state = *state;

  return 0;
}

static usb_error_t uarduno_set_line_coding(struct uarduno_softc *sc, struct usb_cdc_line_state *state)
{
usb_device_request_t req;
usb_error_t err;

  if(!state)
  {
    state = &lsDefault;
  }

  DPRINTF(("uarduno_set_line_coding: rate = %d, fmt = %d, parity = %d bits = %d\n",
           UGETDW(state->dwDTERate), state->bCharFormat,
           state->bParityType, state->bDataBits));

  if(memcmp(state, &sc->sc_line_state, UCDC_LINE_STATE_LENGTH) == 0)
  {
    DPRINTF(("uarduno_set_line_coding: already set\n"));
    return 0;
  }

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_LINE_CODING;
  USETW(req.wValue, 0);
//  USETW(req.wIndex, sc->sc_ctrl_iface_no);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, sizeof(*state));//UCDC_LINE_STATE_LENGTH);

  err = ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
                            &req, state, 0, 1000);
  // NOTE:  NO mutex, and basically the same as calling usbd_do_request() but with
  //        short transfer ALWAYS allowed

  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_line_coding: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
    return err;
  }

  sc->sc_line_state = *state;

  return 0;
}



// NOTE:  this is _ONLY_ called by uarduno_reset and therefore it will invoke
// usbd_do_request_flags directly to prevent crashing on attach
static usb_error_t uarduno_set_line_state_reset(struct uarduno_softc *sc)
{
usb_device_request_t req;
int ls;
usb_error_t err;

//  ls = (sc->sc_line & UCDC_LINE_DTR ? UCDC_LINE_DTR : 0)
//     | (sc->sc_line & UCDC_LINE_RTS ? UCDC_LINE_RTS : 0);

  ls = sc->sc_line;

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_CONTROL_LINE_STATE; // UARDUNO_SET_CONTROL_LINE_STATE

  USETW(req.wValue, ls);
//  USETW(req.wIndex, sc->sc_ctrl_iface_no);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, 0);

//  err = ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
//                            &req, NULL, 0, 1000);
  err = usbd_do_request_flags(sc->sc_udev, NULL, &req, 0, USB_SHORT_XFER_OK,
                              NULL, USB_DEFAULT_TIMEOUT);
  // NOTE:  NO mutex, and basically the same as calling usbd_do_request() but with
  //        short transfer ALWAYS allowed

  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_line_state_reset: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
  }

  return err;
}

static usb_error_t uarduno_reset(struct uarduno_softc *sc, struct usb_device *udev)
{
usb_error_t err;

  err = uarduno_set_line_coding_reset(sc);

  if(!err)
  {
    err = uarduno_set_line_state_reset(sc);
  }

  return err;
}


// this version may be called in the normal request context
static usb_error_t uarduno_set_crtscts(struct uarduno_softc *sc)
{
usb_device_request_t req;
int ls;
usb_error_t err;

//  ls = (sc->sc_line & UCDC_LINE_DTR ? UCDC_LINE_DTR : 0)
//     | (sc->sc_line & UCDC_LINE_RTS ? UCDC_LINE_RTS : 0);

  ls = sc->sc_line;

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_CONTROL_LINE_STATE; // UARDUNO_SET_CONTROL_LINE_STATE

  USETW(req.wValue, ls);
//  USETW(req.wIndex, sc->sc_ctrl_iface_no);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, 0);

  err = ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
                            &req, NULL, 0, 1000);
  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_set_crtscts: %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
  }

  return err;
}

static void uarduno_cfg_set_dtr(struct ucom_softc *ucom, uint8_t onoff)
{
  struct uarduno_softc *sc = ucom->sc_parent;
  struct usb_device_request req;

  DPRINTF("onoff = %d\n", onoff);

  if(onoff)
      sc->sc_line |= UCDC_LINE_DTR;
  else
      sc->sc_line &= ~UCDC_LINE_DTR;

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_CONTROL_LINE_STATE;
  USETW(req.wValue, sc->sc_line);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, 0);

  ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
                      &req, NULL, 0, 1000);
}

static void uarduno_cfg_set_rts(struct ucom_softc *ucom, uint8_t onoff)
{
  struct uarduno_softc *sc = ucom->sc_parent;
  struct usb_device_request req;

  DPRINTF("onoff = %d\n", onoff);

  if(onoff)
    sc->sc_line |= UCDC_LINE_RTS;
  else
    sc->sc_line &= ~UCDC_LINE_RTS;

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SET_CONTROL_LINE_STATE;
  USETW(req.wValue, sc->sc_line);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, 0);

  ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
                      &req, NULL, 0, 1000);
}

static void uarduno_cfg_set_break(struct ucom_softc *ucom, uint8_t onoff)
{
  struct uarduno_softc *sc = ucom->sc_parent;
  struct usb_device_request req;
  uint16_t temp;

  DPRINTF("onoff = %d\n", onoff);

  temp = (onoff ? UCDC_BREAK_ON : UCDC_BREAK_OFF);

  req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
  req.bRequest = UCDC_SEND_BREAK;
  USETW(req.wValue, temp);
  req.wIndex[0] = sc->sc_ctrl_iface_no;
  req.wIndex[1] = 0;
  USETW(req.wLength, 0);

  ucom_cfg_do_request(sc->sc_udev, &sc->sc_ucom,
                      &req, NULL, 0, 1000);
}

static const int32_t uarduno_rates[] = 
{
  75, 150, 300, 600, 1200, 1800, 2400, 3600, 4800, 7200, 9600, 14400,
  19200, 28800, 38400, 57600, 115200,
  // TODO:  check that these higher rates are valid
  230400, 460800, 614400, 921600, 1228800
};

#define N_UARDUNO_RATES (sizeof(uarduno_rates)/sizeof(uarduno_rates[0]))

static int uarduno_pre_param(struct ucom_softc *ucom, struct termios *t)
{
  uint8_t i;

  DPRINTF("\n");

  /* check requested baud rate */

  for (i = 0;; i++)
  {
    if(i != N_UARDUNO_RATES)
    {
      if(uarduno_rates[i] == t->c_ospeed)
      {
        break;
      }
    }
    else
    {
      DPRINTF("invalid baud rate (%d)\n", t->c_ospeed);
      return EIO;
    }
  }

  return 0;
}

static void uarduno_cfg_param(struct ucom_softc *ucom, struct termios *t)
{
struct uarduno_softc *sc = ucom->sc_parent;
struct usb_cdc_line_state ls;
usb_error_t err;


  DPRINTF("sc = %p\n", sc);

  bzero(&ls, sizeof(ls));

  USETDW(ls.dwDTERate, t->c_ospeed);

  if(t->c_cflag & CSTOPB)
  {
    ls.bCharFormat = UCDC_STOP_BIT_2;
  }
  else
  {
    ls.bCharFormat = UCDC_STOP_BIT_1;
  }

  if(t->c_cflag & PARENB)
  {
    if(t->c_cflag & PARODD)
    {
      ls.bParityType = UCDC_PARITY_ODD;
    }
    else
    {
      ls.bParityType = UCDC_PARITY_EVEN;
    }
  }
  else
  {
    ls.bParityType = UCDC_PARITY_NONE;
  }

  switch (ISSET(t->c_cflag, CSIZE))
  {
    case CS5:
      ls.bDataBits = 5;
      break;
    case CS6:
      ls.bDataBits = 6;
      break;
    case CS7:
      ls.bDataBits = 7;
      break;
    case CS8:
      ls.bDataBits = 8;
      break;
  }

  DPRINTF("rate=%d fmt=%d parity=%d bits=%d\n",
          UGETDW(ls.dwDTERate), ls.bCharFormat,
          ls.bParityType, ls.bDataBits);

  err = uarduno_set_line_coding(sc, &ls);
  if(err)
  {
    DPRINTF(("uarduno (%s): uarduno_cfg_param (a): %s\n",
             device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
    return;
  }

  if(ISSET(t->c_cflag, CRTSCTS))
  {
    err = uarduno_set_crtscts(sc);

    if(err)
    {
      DPRINTF(("uarduno (%s): uarduno_cfg_param (b): %s\n",
               device_get_nameunit(sc->sc_ucom.sc_dev), usbd_errstr(err)));
      return;
    }
  }

  return;
}

static void uarduno_start_read(struct ucom_softc *ucom)
{
  struct uarduno_softc *sc = ucom->sc_parent;

  /* start interrupt endpoint */
  usbd_transfer_start(sc->sc_xfer[UARDUNO_INTR_DT_RD]);

  /* start read endpoint */
  usbd_transfer_start(sc->sc_xfer[UARDUNO_BULK_DT_RD]);
}

static void uarduno_stop_read(struct ucom_softc *ucom)
{
  struct uarduno_softc *sc = ucom->sc_parent;

  /* stop interrupt endpoint */
  usbd_transfer_stop(sc->sc_xfer[UARDUNO_INTR_DT_RD]);

  /* stop read endpoint */
  usbd_transfer_stop(sc->sc_xfer[UARDUNO_BULK_DT_RD]);
}

static void uarduno_start_write(struct ucom_softc *ucom)
{
  struct uarduno_softc *sc = ucom->sc_parent;

  usbd_transfer_start(sc->sc_xfer[UARDUNO_BULK_DT_WR]);
}

static void uarduno_stop_write(struct ucom_softc *ucom)
{
  struct uarduno_softc *sc = ucom->sc_parent;

  usbd_transfer_stop(sc->sc_xfer[UARDUNO_BULK_DT_WR]);
}

static void uarduno_cfg_get_status(struct ucom_softc *ucom, uint8_t *lsr, uint8_t *msr)
{
  struct uarduno_softc *sc = ucom->sc_parent;

  DPRINTF("\n");

  *lsr = sc->sc_lsr;
  *msr = sc->sc_msr;
}

static void uarduno_intr_callback(struct usb_xfer *xfer, usb_error_t error)
{
  struct uarduno_softc *sc = usbd_xfer_softc(xfer);
  struct usb_page_cache *pc;
  uint8_t buf[9];
  int actlen;

  usbd_xfer_status(xfer, &actlen, NULL, NULL, NULL);

  switch (USB_GET_STATE(xfer))
  {
    case USB_ST_TRANSFERRED:
      DPRINTF("actlen = %u\n", actlen);

      if(actlen >= 9)
      {
        pc = usbd_xfer_get_frame(xfer, 0);
        usbd_copy_out(pc, 0, buf, sizeof(buf));

        DPRINTF("status = 0x%02x\n", buf[8]);

        sc->sc_lsr = 0;
        sc->sc_msr = 0;

        if(buf[8] & RSAQ_STATUS_CTS)
        {
          sc->sc_msr |= SER_CTS;
        }
        if(buf[8] & RSAQ_STATUS_DSR)
        {
          sc->sc_msr |= SER_DSR;
        }
        if(buf[8] & RSAQ_STATUS_DCD)
        {
          sc->sc_msr |= SER_DCD;
        }
        ucom_status_change(&sc->sc_ucom);
      }

      // this flows through to the next section.  really it needs an 'if'
      // or an inline utility function.  It's an ugly construct.

    case USB_ST_SETUP:
tr_setup: // labels within switch/case statements?  UGLY UGLY UGLY (FIX! use inlines or 'if' blocks)
      usbd_xfer_set_frame_len(xfer, 0, usbd_xfer_max_len(xfer));
      usbd_transfer_submit(xfer);
      return;

    default:            /* Error */
      if(error != USB_ERR_CANCELLED)
      {
        /* try to clear stall first */
        usbd_xfer_set_stall(xfer);
        goto tr_setup;
      }
      return;
  }
}

static void uarduno_write_callback(struct usb_xfer *xfer, usb_error_t error)
{
  struct uarduno_softc *sc = usbd_xfer_softc(xfer);
  struct usb_page_cache *pc;
  uint32_t actlen;

  switch (USB_GET_STATE(xfer))
  {
    case USB_ST_SETUP:
    case USB_ST_TRANSFERRED:
tr_setup: // TODO:  remove ugly label within switch/case for more elegant code
      pc = usbd_xfer_get_frame(xfer, 0);
      if(ucom_get_data(&sc->sc_ucom, pc, 0,
                      UARDUNO_BULK_BUF_SIZE, &actlen))
      {
        DPRINTF("actlen = %d\n", actlen);

        usbd_xfer_set_frame_len(xfer, 0, actlen);
        usbd_transfer_submit(xfer);
      }
      return;

    default:            /* Error */
      if(error != USB_ERR_CANCELLED)
      {
        /* try to clear stall first */
        usbd_xfer_set_stall(xfer);
        goto tr_setup;
      }

      return;
  }
}

static void uarduno_read_callback(struct usb_xfer *xfer, usb_error_t error)
{
  struct uarduno_softc *sc = usbd_xfer_softc(xfer);
  struct usb_page_cache *pc;
  int actlen;

  usbd_xfer_status(xfer, &actlen, NULL, NULL, NULL);

  switch (USB_GET_STATE(xfer))
  {
    case USB_ST_TRANSFERRED:
      pc = usbd_xfer_get_frame(xfer, 0);
      ucom_put_data(&sc->sc_ucom, pc, 0, actlen);

    case USB_ST_SETUP:
tr_setup: // TODO:  remove ugly label within switch/case for more elegant code
      usbd_xfer_set_frame_len(xfer, 0, usbd_xfer_max_len(xfer));
      usbd_transfer_submit(xfer);
      return;

    default:            /* Error */
      if(error != USB_ERR_CANCELLED)
      {
        /* try to clear stall first */
        usbd_xfer_set_stall(xfer);
        goto tr_setup;
      }
      return;
  }
}

static void uarduno_poll(struct ucom_softc *ucom)
{
  struct uarduno_softc *sc = ucom->sc_parent;
  usbd_transfer_poll(sc->sc_xfer, UARDUNO_N_TRANSFER);
}

#endif // KERNELVER

/* end */


